package com.ruoyi.interfaces.service.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

import com.ruoyi.common.core.domain.TreeSelect;
import com.ruoyi.common.core.domain.entity.SysMenu;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.uuid.IdUtils;
import com.ruoyi.interfaces.domain.MdDataCate;
import com.ruoyi.interfaces.domain.TreeSelectString;
import com.ruoyi.interfaces.mapper.MdDataCateMapper;
import com.ruoyi.interfaces.service.IMdDataCateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 数据项分类管理Service业务层处理
 * 
 * @author 朱得糠
 * @date 2025-07-25
 */
@Service
public class MdDataCateServiceImpl implements IMdDataCateService
{
    @Autowired
    private MdDataCateMapper mdDataCateMapper;

    /**
     * 查询数据项分类管理
     * 
     * @param cateId 数据项分类管理主键
     * @return 数据项分类管理
     */
    @Override
    public MdDataCate selectMdDataCateByCateId(String cateId)
    {
        return mdDataCateMapper.selectMdDataCateByCateId(cateId);
    }

    /**
     * 查询数据项分类管理列表
     * 
     * @param mdDataCate 数据项分类管理
     * @return 数据项分类管理
     */
    @Override
    public List<MdDataCate> selectMdDataCateList(MdDataCate mdDataCate)
    {
        return mdDataCateMapper.selectMdDataCateList(mdDataCate);
    }

    /**
     * 新增数据项分类管理
     * 
     * @param mdDataCate 数据项分类管理
     * @return 结果
     */
    @Override
    public int insertMdDataCate(MdDataCate mdDataCate)
    {
        mdDataCate.setCateId(IdUtils.fastUUID());
        mdDataCate.setCreateby(DateUtils.getNowDate());
        return mdDataCateMapper.insertMdDataCate(mdDataCate);
    }

    /**
     * 修改数据项分类管理
     * 
     * @param mdDataCate 数据项分类管理
     * @return 结果
     */
    @Override
    public int updateMdDataCate(MdDataCate mdDataCate)
    {
        mdDataCate.setModifyby(DateUtils.getNowDate());
        return mdDataCateMapper.updateMdDataCate(mdDataCate);
    }

    /**
     * 批量删除数据项分类管理
     * 
     * @param cateIds 需要删除的数据项分类管理主键
     * @return 结果
     */
    @Override
    public int deleteMdDataCateByCateIds(String[] cateIds)
    {
        return mdDataCateMapper.deleteMdDataCateByCateIds(cateIds);
    }

    /**
     * 删除数据项分类管理信息
     * 
     * @param cateId 数据项分类管理主键
     * @return 结果
     */
    @Override
    public int deleteMdDataCateByCateId(String cateId)
    {
        return mdDataCateMapper.deleteMdDataCateByCateId(cateId);
    }

    @Override
    public List<TreeSelectString> buildDataTreeSelect(List<MdDataCate> menus) {

        List<MdDataCate> menuTrees = buildDataTree(menus);
        List<TreeSelectString> collect = menuTrees.stream().map(TreeSelectString::new).collect(Collectors.toList());
        return collect;
    }

    private List<MdDataCate> buildDataTree(List<MdDataCate> menus) {
        List<MdDataCate> returnList = new ArrayList<MdDataCate>();
        List<String> tempList = menus.stream().map(MdDataCate::getCateId).collect(Collectors.toList());
        for (Iterator<MdDataCate> iterator = menus.iterator(); iterator.hasNext();)
        {
            MdDataCate menu = (MdDataCate) iterator.next();
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(menu.getCatePid()))
            {
                recursionFn(menus, menu);
                returnList.add(menu);
            }
        }
        if (returnList.isEmpty())
        {
            returnList = menus;
        }
        return returnList;
    }
    private void recursionFn(List<MdDataCate> list, MdDataCate t)
    {
        // 得到子节点列表
        List<MdDataCate> childList = getChildList(list, t);
        t.setChildren(childList);
        for (MdDataCate tChild : childList)
        {
            if (hasChild(list, tChild))
            {
                recursionFn(list, tChild);
            }
        }
    }
    /**
     * 得到子节点列表
     */
    private List<MdDataCate> getChildList(List<MdDataCate> list, MdDataCate t)
    {
        List<MdDataCate> tlist = new ArrayList<MdDataCate>();
        Iterator<MdDataCate> it = list.iterator();
        while (it.hasNext())
        {
            MdDataCate n = (MdDataCate) it.next();
            if (n.getCatePid().equals(t.getCateId()))
            {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<MdDataCate> list, MdDataCate t)
    {
        return getChildList(list, t).size() > 0;
    }

}
